package com.fp.persistence.pgeneral.auth;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENESOLICITUDECLIENTDATA*/
@Embeddable
public class TgeneSolicitudeClientdataKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="SOLICITUDNUMBER", nullable=false,updatable=false)

/**
* Numero de solicitud
*/
private String solicitudnumber;

@Column(name="SOLICITUDSEQUENCE", nullable=false,updatable=false)

/**
* secuencia interna de solicitud
*/
private Integer solicitudsequence;

@Column(name="TITLE", nullable=false,updatable=false)

/**
* Codigo de informacion de clientes requerido.
*/
private String title;

@Column(name="PERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona asociado a la solicitud.
*/
private Integer personcode;

/**Contructor por defecto*/
public TgeneSolicitudeClientdataKey(){}
/**Contructor de TgeneSolicitudeClientdataKey
@param pSolicitudnumber Numero de solicitud
@param pSolicitudsequence secuencia interna de solicitud
@param pTitle Codigo de informacion de clientes requerido.
@param pPersoncode Codigo de persona asociado a la solicitud.
*/
public TgeneSolicitudeClientdataKey(String pSolicitudnumber,Integer pSolicitudsequence,String pTitle,Integer pPersoncode){
 solicitudnumber=pSolicitudnumber;
 solicitudsequence=pSolicitudsequence;
 title=pTitle;
 personcode=pPersoncode;
}
/**Obtiene el valor de solicitudnumber
@return valor de solicitudnumber*/
public String getSolicitudnumber(){
  return solicitudnumber;
}
/**Fija el valor de solicitudnumber
@param pSolicitudnumber nuevo Valor de solicitudnumber*/
public void setSolicitudnumber(String pSolicitudnumber){
  solicitudnumber=pSolicitudnumber;
}

/**Obtiene el valor de solicitudsequence
@return valor de solicitudsequence*/
public Integer getSolicitudsequence(){
  return solicitudsequence;
}
/**Fija el valor de solicitudsequence
@param pSolicitudsequence nuevo Valor de solicitudsequence*/
public void setSolicitudsequence(Integer pSolicitudsequence){
  solicitudsequence=pSolicitudsequence;
}

/**Obtiene el valor de title
@return valor de title*/
public String getTitle(){
  return title;
}
/**Fija el valor de title
@param pTitle nuevo Valor de title*/
public void setTitle(String pTitle){
  title=pTitle;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Implementación de la comparación de TgeneSolicitudeClientdataKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneSolicitudeClientdataKey))return false;
  TgeneSolicitudeClientdataKey that = (TgeneSolicitudeClientdataKey) o;
  if (this.getSolicitudnumber() == null || that.getSolicitudnumber() == null){
      return false;
  }
  if (! this.getSolicitudnumber().equals(that.getSolicitudnumber())){
    return false;
  }
  if (this.getSolicitudsequence() == null || that.getSolicitudsequence() == null){
      return false;
  }
  if (! this.getSolicitudsequence().equals(that.getSolicitudsequence())){
    return false;
  }
  if (this.getTitle() == null || that.getTitle() == null){
      return false;
  }
  if (! this.getTitle().equals(that.getTitle())){
    return false;
  }
  if (this.getPersoncode() == null || that.getPersoncode() == null){
      return false;
  }
  if (! this.getPersoncode().equals(that.getPersoncode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneSolicitudeClientdataKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getSolicitudnumber() == null ? 0 : this.getSolicitudnumber().hashCode());
    result = result * 37 + (this.getSolicitudsequence() == null ? 0 : this.getSolicitudsequence().hashCode());
    result = result * 37 + (this.getTitle() == null ? 0 : this.getTitle().hashCode());
    result = result * 37 + (this.getPersoncode() == null ? 0 : this.getPersoncode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
